GIT 0.99.8a
[git/jrn.git] / git-fetch.sh
blob61da6a9e3167845cf5b0f9260206b2dd590532df
1 #!/bin/sh
3 . git-sh-setup || die "Not a git archive"
4 . git-parse-remote
5 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
6 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
8 tags=
9 append=
10 force=
11 update_head_ok=
12 while case "$#" in 0) break ;; esac
14 case "$1" in
15 -a|--a|--ap|--app|--appe|--appen|--append)
16 append=t
18 -f|--f|--fo|--for|--forc|--force)
19 force=t
21 -t|--t|--ta|--tag|--tags)
22 tags=t
24 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
25 --update-he|--update-hea|--update-head|--update-head-|\
26 --update-head-o|--update-head-ok)
27 update_head_ok=t
30 break
32 esac
33 shift
34 done
36 case "$#" in
38 test -f "$GIT_DIR/branches/origin" ||
39 test -f "$GIT_DIR/remotes/origin" ||
40 die "Where do you want to fetch from today?"
41 set origin ;;
42 esac
44 remote_nick="$1"
45 remote=$(get_remote_url "$@")
46 refs=
47 rref=
48 rsync_slurped_objects=
50 if test "" = "$append"
51 then
52 : >$GIT_DIR/FETCH_HEAD
55 append_fetch_head () {
56 head_="$1"
57 remote_="$2"
58 remote_name_="$3"
59 remote_nick_="$4"
60 local_name_="$5"
61 case "$6" in
62 t) not_for_merge_='not-for-merge' ;;
63 '') not_for_merge_= ;;
64 esac
66 # remote-nick is the URL given on the command line (or a shorthand)
67 # remote-name is the $GIT_DIR relative refs/ path we computed
68 # for this refspec.
69 case "$remote_name_" in
70 HEAD)
71 note_= ;;
72 refs/heads/*)
73 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
74 note_="branch '$note_' of " ;;
75 refs/tags/*)
76 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
77 note_="tag '$note_' of " ;;
79 note_="$remote_name of " ;;
80 esac
81 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
82 remote_="$remote_1_"
83 note_="$note_$remote_"
85 # 2.6.11-tree tag would not be happy to be fed to resolve.
86 if git-cat-file commit "$head_" >/dev/null 2>&1
87 then
88 headc_=$(git-rev-parse --verify "$head_^0") || exit
89 echo "$headc_ $not_for_merge_ $note_" >>$GIT_DIR/FETCH_HEAD
90 echo >&2 "* committish: $head_"
91 echo >&2 " $note_"
92 else
93 echo "$head_ not-for-merge $note_" >>$GIT_DIR/FETCH_HEAD
94 echo >&2 "* non-commit: $head_"
95 echo >&2 " $note_"
97 if test "$local_name_" != ""
98 then
99 # We are storing the head locally. Make sure that it is
100 # a fast forward (aka "reverse push").
101 fast_forward_local "$local_name_" "$head_" "$note_"
105 fast_forward_local () {
106 mkdir -p "$(dirname "$GIT_DIR/$1")"
107 case "$1" in
108 refs/tags/*)
109 # Tags need not be pointing at commits so there
110 # is no way to guarantee "fast-forward" anyway.
111 if test -f "$GIT_DIR/$1"
112 then
113 echo >&2 "* $1: updating with $3"
114 else
115 echo >&2 "* $1: storing $3"
117 git-update-ref "$1" "$2"
120 refs/heads/*)
121 # $1 is the ref being updated.
122 # $2 is the new value for the ref.
123 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
124 if test "$local"
125 then
126 # Require fast-forward.
127 mb=$(git-merge-base "$local" "$2") &&
128 case "$2,$mb" in
129 $local,*)
130 echo >&2 "* $1: same as $3"
132 *,$local)
133 echo >&2 "* $1: fast forward to $3"
134 git-update-ref "$1" "$2" "$local"
137 false
139 esac || {
140 echo >&2 "* $1: does not fast forward to $3;"
141 case ",$force,$single_force," in
142 *,t,*)
143 echo >&2 " forcing update."
144 git-update-ref "$1" "$2" "$local"
147 echo >&2 " not updating."
149 esac
151 else
152 echo >&2 "* $1: storing $3"
153 git-update-ref "$1" "$2"
156 esac
159 case "$update_head_ok" in
161 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
163 esac
165 # If --tags (and later --heads or --all) is specified, then we are
166 # not talking about defaults stored in Pull: line of remotes or
167 # branches file, and just fetch those and refspecs explicitly given.
168 # Otherwise we do what we always did.
170 reflist=$(get_remote_refs_for_fetch "$@")
171 if test "$tags"
172 then
173 taglist=$(git-ls-remote --tags "$remote" | awk '{ print "."$2":"$2 }')
174 if test "$#" -gt 1
175 then
176 # remote URL plus explicit refspecs; we need to merge them.
177 reflist="$reflist $taglist"
178 else
179 # No explicit refspecs; fetch tags only.
180 reflist=$taglist
184 for ref in $reflist
186 refs="$refs $ref"
188 # These are relative path from $GIT_DIR, typically starting at refs/
189 # but may be HEAD
190 if expr "$ref" : '\.' >/dev/null
191 then
192 not_for_merge=t
193 ref=$(expr "$ref" : '\.\(.*\)')
194 else
195 not_for_merge=
197 if expr "$ref" : '\+' >/dev/null
198 then
199 single_force=t
200 ref=$(expr "$ref" : '\+\(.*\)')
201 else
202 single_force=
204 remote_name=$(expr "$ref" : '\([^:]*\):')
205 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
207 rref="$rref $remote_name"
209 # There are transports that can fetch only one head at a time...
210 case "$remote" in
211 http://* | https://*)
212 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
213 curl_extra_args="-k"
215 head=$(curl -nsf $curl_extra_args "$remote/$remote_name") &&
216 expr "$head" : "$_x40\$" >/dev/null ||
217 die "Failed to fetch $remote_name from $remote"
218 echo >&2 Fetching "$remote_name from $remote" using http
219 git-http-fetch -v -a "$head" "$remote/" || exit
221 rsync://*)
222 TMP_HEAD="$GIT_DIR/TMP_HEAD"
223 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
224 head=$(git-rev-parse --verify TMP_HEAD)
225 rm -f "$TMP_HEAD"
226 test "$rsync_slurped_objects" || {
227 rsync -av --ignore-existing --exclude info \
228 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
230 # Look at objects/info/alternates for rsync -- http will
231 # support it natively and git native ones will do it on the remote
232 # end. Not having that file is not a crime.
233 rsync -q "$remote/objects/info/alternates" \
234 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
235 rm -f "$GIT_DIR/TMP_ALT"
236 if test -f "$GIT_DIR/TMP_ALT"
237 then
238 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
239 while read alt
241 case "$alt" in 'bad alternate: '*) die "$alt";; esac
242 echo >&2 "Getting alternate: $alt"
243 rsync -av --ignore-existing --exclude info \
244 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
245 done
246 rm -f "$GIT_DIR/TMP_ALT"
248 rsync_slurped_objects=t
252 # We will do git native transport with just one call later.
253 continue ;;
254 esac
256 append_fetch_head "$head" "$remote" \
257 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
259 done
261 case "$remote" in
262 http://* | https://* | rsync://* )
263 ;; # we are already done.
266 git-fetch-pack "$remote" $rref || echo failed "$remote"
268 while read sha1 remote_name
270 case "$sha1" in
271 failed)
272 echo >&2 "Fetch failure: $remote"
273 exit 1 ;;
274 esac
275 found=
276 single_force=
277 for ref in $refs
279 case "$ref" in
280 +$remote_name:*)
281 single_force=t
282 not_for_merge=
283 found="$ref"
284 break ;;
285 .+$remote_name:*)
286 single_force=t
287 not_for_merge=t
288 found="$ref"
289 break ;;
290 .$remote_name:*)
291 not_for_merge=t
292 found="$ref"
293 break ;;
294 $remote_name:*)
295 not_for_merge=
296 found="$ref"
297 break ;;
298 esac
299 done
300 local_name=$(expr "$found" : '[^:]*:\(.*\)')
301 append_fetch_head "$sha1" "$remote" \
302 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
303 done || exit
305 esac
307 # If the original head was empty (i.e. no "master" yet), or
308 # if we were told not to worry, we do not have to check.
309 case ",$update_head_ok,$orig_head," in
310 *,, | t,* )
313 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
314 if test "$curr_head" != "$orig_head"
315 then
316 git-update-ref HEAD "$orig_head"
317 die "Cannot fetch into the current branch."
320 esac